// -*- mode:C++; tab-width:4; c-basic-offset:4; indent-tabs-mode:nil -*-

/*
 * Copyright: (C) 2010 RobotCub Consortium
 * Author: Paul Fitzpatrick
 * CopyPolicy: Released under the terms of the LGPLv2.1 or later, see LGPL.TXT
 */

#define YARP_ADDRESS_HOST_MAXLEN 100

typedef struct yarpAddressStruct {
  char host[YARP_ADDRESS_HOST_MAXLEN];
  int port_number;
} yarpAddress;
typedef yarpAddress *yarpAddressPtr;

typedef long int yarpConnection;

yarpAddressPtr yarp_init();

void yarp_fini();

yarpConnection yarp_connect(yarpAddressPtr address);
int yarp_is_valid(yarpConnection connection);
void yarp_disconnect(yarpConnection connection);

int yarp_send(yarpConnection connection, const char *msg);
int yarp_send_binary(yarpConnection connection, const char *msg, int len);
int yarp_receive(yarpConnection connection, char *buf, int len);
int yarp_receive_line(yarpConnection connection, char *buf, int len);
int yarp_receive_binary(yarpConnection connection, char *buf, int len);

int yarp_receive_data_header(yarpConnection connection);

int yarp_parse_registration(yarpAddressPtr address, char *buf);
int yarp_port_lookup(yarpAddressPtr address, const char *port_name);

int yarp_rpc(yarpAddressPtr address, const char *msg, char *buf, int len);

int yarp_read_int(const char *buf, int len);
int yarp_write_int(char *buf, int len, int x);

yarpConnection yarp_prepare_to_read(yarpAddressPtr address);

yarpConnection yarp_prepare_to_read_binary(yarpAddressPtr address);
